var boundary="hellothisisplasocontentdososos"
var util=require("util")
var file=require("./file");
var json=require("./json");
async function checkData(params) {
    var multi=false;
    for(var key in params){
        var value=params[key];
        if(value instanceof file){
            multi=true;
            break;
        }
    }
    if(!multi){
        return null;
    }
    var allContent=Buffer.alloc(0);
    for(var key in params){
        var value=params[key];
        if(value instanceof file){
            value=await genFileContent(key,value);
        }else if(value instanceof json){
            value=genContent(key,JSON.stringify(value.obj),"application/json","json");
        }else{
            value=genContent(key,""+value);
        }
        allContent=Buffer.concat([allContent,value]);
    }
    allContent=Buffer.concat([allContent,Buffer.from("--"+boundary+"--\r\n\r\n","utf8")]);
    return ["multipart/form-data; boundary=" + boundary,allContent];
}

async function genFileContent(name,file){
    var filePath=file.path,fileType=file.type||"application/octet-stream"
    var path=require("path")
    var fs=require("fs")
    var fileName=path.basename(filePath);
    var readFile=util.promisify(fs.readFile)
    var content=await readFile(filePath);
    return genContent(name,content,fileType,fileName);
}
function genContent(name,content,type,filename) {
    var data = "--" + boundary + "\r\n";
    data += `Content-Disposition: form-data; name="${name}";`
    if(filename) {
        data+=`filename="${filename}"`
    }
    data+="\r\n"
    if(type){
        data += `Content-Type:${type}\r\n`
    }
    data+="\r\n"
    var payload = Buffer.concat([
            Buffer.from(data, "utf8"),
            new Buffer(content, 'binary'),
            Buffer.from("\r\n", "utf8")
   //         Buffer.from("\r\n--" + boundary + "\r\n", "utf8"),
    ]);
    return payload; 
}

/*    var options = {
        method: 'post',
        url: url,
        headers: {"Content-Type": "multipart/form-data; boundary=" + boundary},
        body: payload,
    };
}*/
module.exports=checkData;