package com.plaso.client;
import java.io.*;
import java.lang.annotation.Annotation;
import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Method;
import java.lang.reflect.Proxy;
import java.net.HttpURLConnection;
import java.net.URL;


import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;


public class Client implements InvocationHandler{

	private int port;
	private String host;
	private String prefix;

	public Client(int port, String host,String protocal) {
		this.port = port;
		this.host = host;
		this.protocal=protocal;
	}
	public Client(int port, String host) {
		this(port,host,"http");
	}
	public Client(String host,String protocal) {
		this(0,host,protocal);
	}

	public Object register(Class<?> cls) {
		Object newProxyInstance = Proxy.newProxyInstance(cls.getClassLoader(), new Class[] { cls },this);
		return newProxyInstance;

	}

	public Object invoke(Object proxy, Method method, Object[] args) throws Throwable {
		// TODO Auto-generated method stub
		String data = JSON.toJSONString(args);
		/**/Desc anno = method.getAnnotation(Desc.class);
		String path=anno.path();
		if(path==null){
			throw new Exception("path is not defiend");
		}
		//String dataValue="{\"c\":0,\"o\":{\"i\":10}}";
		String dataValue=sendData(path,data);//"{\"c\":0,\"o\":{\"i\":10}}";

		JSONObject resultvalue = JSON.parseObject(dataValue);
		int code=(Integer)resultvalue.get("c");
		if(code!=0){
			return null;
		}
		JSONObject obj = (JSONObject) resultvalue.get("o");
		return obj.toJavaObject(method.getReturnType());
	}

	private String sendData(String path,String dataStr) {
		try {
			URL url ;
			if(this.port==0){
				url=new URL(this.protocal,this.host,path);
			}else{
				url=new URL(this.protocal,this.host,this.port,path);
			}

			HttpURLConnection connection = (HttpURLConnection) url.openConnection();
			connect.setRequestProperty("Content-type", "application/json"); 
			connection.setDoOutput(true);
			connection.setDoInput(true);
			connection.setUseCaches(false);
			connection.setConnectTimeout(30000);
			connection.setReadTimeout(30000);
			connection.connect();
			OutputStream outputStream = connection.getOutputStream();
			outputStream.write(dataStr.getBytes());
			outputStream.close();
			InputStream inputStream = connection.getInputStream();
			ByteArrayOutputStream baos = new ByteArrayOutputStream();
			byte[] buffer = new byte[1024];
			int len = 0;
			while ((len = inputStream.read(buffer)) != -1) {
				baos.write(buffer, 0, len);
			}
			byte[] b = baos.toByteArray();
			inputStream.close();
			baos.close();
			String message = new String(b);
			inputStream.close();
			connection.disconnect();
			return message;
		} catch (IOException e) {
			e.printStackTrace();
		}
		return "{}";
	}
}